#include "./Timer.h"
#include "./SEG.h"
#include "./LED.h"
#include "./Key.h"
#include "./RTC.h"
#include "./DS18B20.h"
#include "./ds1302.h"
#include "./onewire.h"
#include "./System.h"
#include "./config.h"

SEG_Tag_TypeDef xdata seg_tag;//

//ܶѡ
uchar code Seg_Table[] =
{
	0xc0, //0
	0xf9, //1
	0xa4, //2
	0xb0, //3
	0x99, //4
	0x92, //5
	0x82, //6
	0xf8, //7
	0x80, //8
	0x90, //9
	0x88, //A
	0x83, //b
	0xc6, //C
	0xa1, //d
	0x86, //E
	0x8e  //F
};

//λѡ
uchar code Wei_Table[] =
{
	0X01,
	0X02,
	0X04,
	0X08,
	0X10,
	0X20,
	0X40,
	0X80,
};

//ܱʼ
void SEG_Tag_Init()
{
	uchar i;//
	for(i=0;i<sizeof(seg_tag.SEG_Wei);i++)
	{
		seg_tag.SEG_Wei[i]=0x00;
	}
	
	for(i=0;i<sizeof(seg_tag.SEG_Duan);i++)
	{
		seg_tag.SEG_Duan[i]=0x00;
	}
}

//ʾʱ亯
//XX-XX-XXʽ
void SEG_Display_Time(uchar hour,uchar min,uchar sec)
{
	uchar wei;//λѡֵ
	uchar hour1,hour2;//Сʱ
	uchar min1,min2;//
	uchar sec1,sec2;//
	
	hour1=hour/10;//Сʱ
	hour2=hour%10;//Сʱ
	min1=min/10;//
	min2=min%10;//
	sec1=sec/10;//
	sec2=sec%10;//
	
	//
	Write_HC573(0XC0,0XFF);
	Write_HC573(0XE0,0XFF);
	
	Write_HC573(0XC0,Wei_Table[wei]);//дλѡֵ
	switch(wei)
	{
		case 0:
			Write_HC573(0XE0,Seg_Table[hour1]);
			break;
		
		case 1:
			Write_HC573(0XE0,Seg_Table[hour2]);
			break;
		
		case 2:
			Write_HC573(0XE0,0XBF);
			break;
		
		case 3:
			Write_HC573(0XE0,Seg_Table[min1]);
			break;
		
		case 4:
			Write_HC573(0XE0,Seg_Table[min2]);
			break;
		
		case 5:
			Write_HC573(0XE0,0XBF);
			break;
		
		case 6:
			Write_HC573(0XE0,Seg_Table[sec1]);
			break;
		
		case 7:
			Write_HC573(0XE0,Seg_Table[sec2]);
			break;
	}
	wei++;
	if(wei>7) wei=0;
}

//ʾ¶Ⱥ
//XXCʽ
void SEG_Display_Temp(uint temp)
{
	uchar wei;//λѡֵ
	uchar temp1,temp2;//¶ֵ
	
	temp1=temp/10;
	temp2=temp%10;
	
	//
	Write_HC573(0XC0,0XFF);
	Write_HC573(0XE0,0XFF);
	
	Write_HC573(0XC0,Wei_Table[wei]);//дλѡֵ
	switch(wei)
	{
		case 5:
			Write_HC573(0XE0,Seg_Table[temp1]);
			break;
		
		case 6:
			Write_HC573(0XE0,Seg_Table[temp2]);
			break;
		
		case 7:
			Write_HC573(0XE0,Seg_Table[0X0C]);//C
			break;
		
		default:
			Write_HC573(0XE0,0XFF);
			break;
	}
	wei++;
	if(wei>7) wei=0;	
}

//Сʱ˸
void SEG_Blink_Hour(uchar min,uchar sec)
{
	uchar wei;//λѡֵ
	uchar min1,min2;//
	uchar sec1,sec2;//
	
	min1=min/10;//
	min2=min%10;//
	sec1=sec/10;//
	sec2=sec%10;//
	
	//
	Write_HC573(0XC0,0XFF);
	Write_HC573(0XE0,0XFF);
	
	Write_HC573(0XC0,Wei_Table[wei]);//дλѡֵ
	switch(wei)
	{
		case 0:
			Write_HC573(0XE0, 0XFF);
			break;
		
		case 1:
			Write_HC573(0XE0,0XFF);
			break;
		
		case 2:
			Write_HC573(0XE0,0XBF);
			break;
		
		case 3:
			Write_HC573(0XE0,Seg_Table[min1]);
			break;
		
		case 4:
			Write_HC573(0XE0,Seg_Table[min2]);
			break;
		
		case 5:
			Write_HC573(0XE0,0XBF);
			break;
		
		case 6:
			Write_HC573(0XE0,Seg_Table[sec1]);
			break;
		
		case 7:
			Write_HC573(0XE0,Seg_Table[sec2]);
			break;
	}
	wei++;
	if(wei>7) wei=0;
}

//ܷ˸
void SEG_Blink_Min(uchar hour,uchar sec)
{
	uchar wei;//λѡֵ
	uchar hour1,hour2;//Сʱ
	uchar sec1,sec2;//
	
	hour1=hour/10;//Сʱ
	hour2=hour%10;//Сʱ
	sec1=sec/10;//
	sec2=sec%10;//
	
	//
	Write_HC573(0XC0,0XFF);
	Write_HC573(0XE0,0XFF);
	
	Write_HC573(0XC0,Wei_Table[wei]);//дλѡֵ
	switch(wei)
	{
		case 0:
			Write_HC573(0XE0,Seg_Table[hour1]);
			break;
		
		case 1:
			Write_HC573(0XE0,Seg_Table[hour2]);
			break;
		
		case 2:
			Write_HC573(0XE0,0XBF);
			break;
		
		case 3:
			Write_HC573(0XE0,0XFF);
			break;
		
		case 4:
			Write_HC573(0XE0,0XFF);
			break;
		
		case 5:
			Write_HC573(0XE0,0XBF);
			break;
		
		case 6:
			Write_HC573(0XE0,Seg_Table[sec1]);
			break;
		
		case 7:
			Write_HC573(0XE0,Seg_Table[sec2]);
			break;
	}
	wei++;
	if(wei>7) wei=0;
}

//˸
void SEG_Blink_Sec(uchar hour,uchar min)
{
	uchar wei;//λѡֵ
	uchar min1,min2;//
	uchar hour1,hour2;//Сʱ
	
	hour1=hour/10;//Сʱ
	hour2=hour%10;//Сʱ	
	min1=min/10;//
	min2=min%10;//
	
	//
	Write_HC573(0XC0,0XFF);
	Write_HC573(0XE0,0XFF);
	
	Write_HC573(0XC0,Wei_Table[wei]);//дλѡֵ
	switch(wei)
	{
		case 0:
			Write_HC573(0XE0,Seg_Table[hour1]);
			break;
		
		case 1:
			Write_HC573(0XE0,Seg_Table[hour2]);
			break;
		
		case 2:
			Write_HC573(0XE0,0XBF);
			break;
		
		case 3:
			Write_HC573(0XE0,Seg_Table[min1]);
			break;
		
		case 4:
			Write_HC573(0XE0,Seg_Table[min2]);
			break;
		
		case 5:
			Write_HC573(0XE0,0XBF);
			break;
		
		case 6:
			Write_HC573(0XE0,0XFF);
			break;
		
		case 7:
			Write_HC573(0XE0,0XFF);
			break;
	}
	wei++;
	if(wei>7) wei=0;
}